<script lang="ts">
  import type { PlayerId, State } from "../../server";
  import { createActionDispatcher } from "../util/createActionDispatcher";

  const dispatchAction = createActionDispatcher();

  export let actorId: PlayerId;
  export let state: State;

  let selectedPlayer: PlayerId | null = null;

  let otherPlayers = state.players.filter((p) => p.id !== actorId);
</script>

<section>
  <h3>Peek at a player's hand.</h3>
  <ul>
    {#each otherPlayers as player}
      <li>
        <label
          for="peek-target-{player.id}"
          class:disabled={player.hand.length === 0}
        >
          {#if player.protected}
            <span class="emoji">🛡</span>
          {:else}
            <input
              type="radio"
              disabled={player.hand.length === 0}
              name="peek-target"
              id="peek-target-{player.id}"
              bind:group={selectedPlayer}
              value={player.id}
            />
          {/if}
          <gs6-user playerid={player.id} />
        </label>
      </li>
    {/each}
  </ul>

  <button
    class="primary"
    disabled={selectedPlayer === null}
    on:click={() => {
      if (selectedPlayer !== null) {
        dispatchAction({ kind: "Peek", target: selectedPlayer });
      }
    }}
  >
    Peek!
  </button>
</section>

<style>
  section {
    display: flex;
    flex-direction: column;
    align-items: center;
  }
  li {
    margin-block-start: 0.25em;
    margin-block-end: 0.25em;
    white-space: nowrap;
  }

  .disabled {
    filter: grayscale(0.9) opacity(0.5);
  }
</style>
